package com.logicbig.example;

import org.springframework.context.ApplicationEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class BuildInListenerBasedMultipleEventExample {

    @Bean
    AListenerBean listenerBean () {
        return new AListenerBean();
    }

    public static void main (String[] args) {
        AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext(
                            BuildInListenerBasedMultipleEventExample.class);
        context.stop();
        context.start();
        context.close();

    }

    private static class AListenerBean implements ApplicationListener<ApplicationEvent> {

        @Override
        public void onApplicationEvent (ApplicationEvent event) {
            System.out.println("event received: "+event);
        }
    }
}